Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_end_cycle.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_end_cycle.cpp	(revision 88)
@@ -0,0 +1,47 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::end_cycle"
+void Reexecute_unit::end_cycle ()
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
+#endif
+
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_commit.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_commit.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_commit.cpp	(revision 88)
@@ -0,0 +1,140 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::genMealy_commit"
+  void Reexecute_unit::genMealy_commit (void)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    // Initialisation
+    Tcontrol_t execute_loop_ack [_param->_nb_execute_loop][_param->_max_nb_inst_execute];
+
+    for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_param->_nb_inst_execute [i]; ++j)
+	execute_loop_ack [i][j] = false;
+
+    for (uint32_t i=0; i<_param->_nb_bank; i++)
+      internal_QUEUE_PUSH [i] = 0;
+
+    // execute_loop interface
+    std::list<generic::priority::select_t> * select_queue_in        = _priority_queue_in ->select();
+    std::list<generic::priority::select_t>::iterator it_queue_in    = select_queue_in    ->begin();
+
+    std::list<generic::priority::select_t> * select_execute_loop    = _priority_execute_loop ->select();
+    std::list<generic::priority::select_t>::iterator it_execute_loop= select_execute_loop ->begin();
+  
+    // For each nb_inst
+    for (uint32_t i=0; i<_param->_nb_inst_commit; ++i)
+      {
+	Tcontrol_t commit_val = false;
+
+	// find a executed instruction
+	for (;
+	     (it_execute_loop!=select_execute_loop->end()) and (commit_val == false);
+	     ++it_execute_loop)
+	  {
+	    // take num_execute_loop and num_inst_execute
+	    uint32_t x = it_execute_loop->grp;
+	    uint32_t y = it_execute_loop->elt;
+
+	    // test id instruction is valid
+	    if (PORT_READ(in_EXECUTE_LOOP_VAL [x][y]))
+	      {
+		// Need spr_acces / reexecute ?
+		Texception_t    exception  = PORT_READ(in_EXECUTE_LOOP_EXCEPTION [x][y]);
+		Tgeneral_data_t address    = PORT_READ(in_EXECUTE_LOOP_ADDRESS   [x][y]);
+		Tcontrol_t      spr_access = ((exception ==  EXCEPTION_ALU_SPR_ACCESS_MUST_READ ) or
+					      (exception ==  EXCEPTION_ALU_SPR_ACCESS_MUST_WRITE));
+		if (spr_access)
+		  {
+		    // find a not full bank
+		    bool find = false;
+		    for (;
+			 (it_queue_in!=select_queue_in->end()) and (find == false);
+			 ++it_queue_in)
+		      {
+			uint32_t num_bank = it_queue_in->grp;
+			if (_reexecute_queue [num_bank].size() < _param->_size_queue)
+			  {
+			    find = true;
+			    
+			    // this instruction don't need spr access. send at the re order buffer
+			    commit_val              = 1; // in_EXECUTE_LOOP_VAL = 1
+			    execute_loop_ack [x][y] = PORT_READ(in_COMMIT_ACK [i]);
+			    
+			    internal_QUEUE_PUSH                [num_bank] = execute_loop_ack [x][y]; // in_EXECUTE_LOOP_VAL = 1
+			    internal_QUEUE_NUM_EXECUTE_LOOP    [num_bank] = x;
+			    internal_QUEUE_NUM_INST_EXECUTE    [num_bank] = y;
+			    internal_QUEUE_NUM_INST_COMMIT     [num_bank] = i;
+			    internal_QUEUE_INFO                [num_bank].spr_wen = (exception ==  EXCEPTION_ALU_SPR_ACCESS_MUST_WRITE);
+			    
+			    // if reexecute, don't commit, just read instruction information (num_reg_rd)
+			    PORT_WRITE(out_COMMIT_WEN          [i], not must_reexecute(address & 0xffff, internal_QUEUE_INFO[num_bank]));
+			  }
+		      }
+		  }
+		else
+		  {
+		    // this instruction don't need spr access. send at the re order buffer
+		    commit_val              = 1; // in_EXECUTE_LOOP_VAL = 1
+		    execute_loop_ack [x][y] = PORT_READ(in_COMMIT_ACK [i]);
+
+		    PORT_WRITE(out_COMMIT_WEN          [i], 1);
+		  }
+		
+		if (commit_val)
+		  {
+		    if (_param->_have_port_context_id)
+		    PORT_WRITE(out_COMMIT_CONTEXT_ID   [i], PORT_READ(in_EXECUTE_LOOP_CONTEXT_ID   [x][y]));
+		    if (_param->_have_port_front_end_id)
+		    PORT_WRITE(out_COMMIT_FRONT_END_ID [i], PORT_READ(in_EXECUTE_LOOP_FRONT_END_ID [x][y]));
+		    if (_param->_have_port_rob_ptr  )
+		    PORT_WRITE(out_COMMIT_PACKET_ID    [i], PORT_READ(in_EXECUTE_LOOP_PACKET_ID    [x][y]));
+		  //PORT_WRITE(out_COMMIT_OPERATION    [i], PORT_READ(in_EXECUTE_LOOP_OPERATION    [x][y]));
+		  //PORT_WRITE(out_COMMIT_TYPE         [i], PORT_READ(in_EXECUTE_LOOP_TYPE         [x][y]));
+		    PORT_WRITE(out_COMMIT_FLAGS        [i], PORT_READ(in_EXECUTE_LOOP_FLAGS        [x][y]));
+		    PORT_WRITE(out_COMMIT_EXCEPTION    [i], exception);
+		    PORT_WRITE(out_COMMIT_NO_SEQUENCE  [i], PORT_READ(in_EXECUTE_LOOP_NO_SEQUENCE  [x][y]));
+		    PORT_WRITE(out_COMMIT_ADDRESS      [i], address);
+		  }
+	      }
+	  }
+	
+#ifdef STATISTICS
+	internal_COMMIT_VAL [i] = commit_val;
+#endif
+	PORT_WRITE(out_COMMIT_VAL [i], commit_val);
+      }
+
+    for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_param->_nb_inst_execute [i]; ++j)
+	PORT_WRITE(out_EXECUTE_LOOP_ACK [i][j], execute_loop_ack [i][j]);
+
+    log_end(Reexecute_unit,FUNCTION);
+  };
+  
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+
+
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_reexecute.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_reexecute.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMealy_reexecute.cpp	(revision 88)
@@ -0,0 +1,93 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::genMealy_reexecute"
+  void Reexecute_unit::genMealy_reexecute (void)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    // ===================================================================
+    // =====[ REEXECUTE ]=================================================
+    // ===================================================================
+    // Between reexecute_rob and rexecute_queue, reexecute_queue is most priotary
+    
+    for (uint32_t i=0; i<_param->_nb_inst_reexecute; i++)
+      {
+	Tcontrol_t val;
+	Tcontrol_t ack;
+
+	if (not _reexecute_queue [i].empty() and (_reexecute_queue [i].front()->state == STATE_REEXECUTE))
+	  {
+	    val = true ;
+	    ack = false;
+
+	    entry_t * entry = _reexecute_queue [i].front();
+
+	    if (_param->_have_port_context_id)
+	    PORT_WRITE(out_REEXECUTE_CONTEXT_ID            [i],entry->context_id    );
+	    if (_param->_have_port_front_end_id)
+	    PORT_WRITE(out_REEXECUTE_FRONT_END_ID          [i],entry->front_end_id  );
+	    if (_param->_have_port_rob_ptr  )
+	    PORT_WRITE(out_REEXECUTE_PACKET_ID             [i],entry->packet_id     );
+	    PORT_WRITE(out_REEXECUTE_OPERATION             [i],entry->operation     );
+	    PORT_WRITE(out_REEXECUTE_TYPE                  [i],entry->type          );
+	    PORT_WRITE(out_REEXECUTE_STORE_QUEUE_PTR_WRITE [i],0);
+	    PORT_WRITE(out_REEXECUTE_HAS_IMMEDIAT          [i],1);
+	    PORT_WRITE(out_REEXECUTE_IMMEDIAT              [i],entry->data          );
+	    PORT_WRITE(out_REEXECUTE_WRITE_RD              [i],entry->write_rd      );
+	    PORT_WRITE(out_REEXECUTE_NUM_REG_RD            [i],entry->num_reg_rd    );
+	  }
+	else
+	  {
+	    val = PORT_READ(in_REEXECUTE_ROB_VAL [i]);
+	    ack = PORT_READ(in_REEXECUTE_ACK     [i]);
+
+	    if (_param->_have_port_context_id)
+	    PORT_WRITE(out_REEXECUTE_CONTEXT_ID            [i], PORT_READ(in_REEXECUTE_ROB_CONTEXT_ID              [i]));
+	    if (_param->_have_port_front_end_id)
+	    PORT_WRITE(out_REEXECUTE_FRONT_END_ID          [i], PORT_READ(in_REEXECUTE_ROB_FRONT_END_ID            [i]));
+	    if (_param->_have_port_rob_ptr  )
+	    PORT_WRITE(out_REEXECUTE_PACKET_ID             [i], PORT_READ(in_REEXECUTE_ROB_PACKET_ID               [i]));
+	    PORT_WRITE(out_REEXECUTE_OPERATION             [i], PORT_READ(in_REEXECUTE_ROB_OPERATION               [i]));
+	    PORT_WRITE(out_REEXECUTE_TYPE                  [i], PORT_READ(in_REEXECUTE_ROB_TYPE                    [i]));
+	    PORT_WRITE(out_REEXECUTE_STORE_QUEUE_PTR_WRITE [i], PORT_READ(in_REEXECUTE_ROB_STORE_QUEUE_PTR_WRITE   [i]));
+	    PORT_WRITE(out_REEXECUTE_HAS_IMMEDIAT          [i], 0);
+	    PORT_WRITE(out_REEXECUTE_IMMEDIAT              [i], 0);
+	    PORT_WRITE(out_REEXECUTE_WRITE_RD              [i], 0);
+	    PORT_WRITE(out_REEXECUTE_NUM_REG_RD            [i], 0);
+	  }
+
+	internal_REEXECUTE_VAL     [i] = val;
+	internal_REEXECUTE_ROB_ACK [i] = ack;
+
+	PORT_WRITE(out_REEXECUTE_VAL     [i], internal_REEXECUTE_VAL     [i]);
+	PORT_WRITE(out_REEXECUTE_ROB_ACK [i], internal_REEXECUTE_ROB_ACK [i]);
+      }
+
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMoore.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMoore.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_genMoore.cpp	(revision 88)
@@ -0,0 +1,61 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::genMoore"
+  void Reexecute_unit::genMoore (void)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    // ===================================================================
+    // =====[ SPR ]=======================================================
+    // ===================================================================
+    for (uint32_t i=0; i<_param->_nb_inst_reexecute; i++)
+      {
+	Tcontrol_t val = (not _reexecute_queue [i].empty() and
+			  (_reexecute_queue [i].front()->state == STATE_SPR_ACCESS));
+
+	if (val)
+	  {
+	    entry_t * entry = _reexecute_queue [i].front();
+
+	    PORT_WRITE(out_SPR_WEN          [i],entry->spr_wen);
+	    if (_param->_have_port_context_id)
+	    PORT_WRITE(out_SPR_CONTEXT_ID   [i],entry->context_id);
+	    if (_param->_have_port_front_end_id)
+	    PORT_WRITE(out_SPR_FRONT_END_ID [i],entry->front_end_id);
+	    PORT_WRITE(out_SPR_NUM_GROUP    [i],(entry->address >> _param->_shift_spr_num_group) & _param->_mask_spr_num_group);
+	    PORT_WRITE(out_SPR_NUM_REG      [i],(entry->address                                ) & _param->_mask_spr_num_reg  );
+	    PORT_WRITE(out_SPR_WDATA        [i],entry->data);
+	  }
+
+	internal_SPR_VAL [i] = val;
+	PORT_WRITE(out_SPR_VAL [i], internal_SPR_VAL [i]);
+      }
+
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_must_reexecute.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_must_reexecute.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_must_reexecute.cpp	(revision 88)
@@ -0,0 +1,86 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::must_reexecute"
+  bool Reexecute_unit::must_reexecute (Tspr_address_t address, info_t & info)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    // Test if need reexecute
+    if (info.spr_wen)
+      {
+	// ***** SPR WRITE *****
+	
+	Tspr_address_t num_group = (address >> _param->_shift_spr_num_group) & _param->_mask_spr_num_group;
+	Tspr_address_t num_reg   = (address                                ) & _param->_mask_spr_num_reg  ;
+	
+	switch (num_group)
+	  {
+	  case GROUP_DCACHE :
+	    {
+	      info.type     = TYPE_MEMORY;
+	      info.write_rd = 0;
+	      
+	      switch (num_reg)
+		{
+		case SPR_DCBPR : {info.reexecute = true; info.operation = OPERATION_MEMORY_PREFETCH  ; break;}
+		case SPR_DCBFR : {info.reexecute = true; info.operation = OPERATION_MEMORY_FLUSH     ; break;}
+		case SPR_DCBIR : {info.reexecute = true; info.operation = OPERATION_MEMORY_INVALIDATE; break;}
+// 		case SPR_DCBWR : {info.reexecute = true; info.operation = OPERATION_MEMORY_FLUSH     ; break;}
+		case SPR_DCBLR : {info.reexecute = true; info.operation = OPERATION_MEMORY_LOCK      ; break;}
+		default :
+		  {
+		    info.reexecute = false;
+		    break;
+		  }
+		}
+	      
+	      break;
+	    }
+	  default :
+	    {
+	      info.reexecute = false;
+	      break;
+	    }
+	  }
+      }
+    else
+      {
+	// ***** SPR READ *****
+	info.reexecute = true;
+	info.type      = TYPE_ALU;
+	info.operation = OPERATION_ALU_L_OR;
+	info.write_rd  = 1;
+      }
+
+    log_end(Reexecute_unit,FUNCTION);
+
+    return info.reexecute;
+  }
+  
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
+
+
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,74 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::statistics_allocation"
+  void Reexecute_unit::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Reexecute_unit",
+		      param_statistics);
+
+    _stat_bank_nb_inst     = new counter_t * [_param->_nb_bank];
+
+    // bank/queue occupation
+    {
+      std::string sum_bank_nb_inst = "";
+      for (uint32_t i=0; i<_param->_nb_bank; i++)
+	{
+	  _stat_bank_nb_inst [i] = _stat->create_variable("bank_nb_inst_"+toString(i));
+	  
+	  _stat->create_expr_average_by_cycle("average_occupation_bank_"+toString(i), "bank_nb_inst_"+toString(i), "", toString(_("Average instruction by cycle (bank %d)"),i));
+	  _stat->create_expr_percent         ("percent_occupation_bank_"+toString(i), "average_occupation_bank_"+toString(i), toString(_param->_size_bank), toString(_("Percent occupation of bank (bank %d)"),i));
+	  
+	  if (i == 0)
+	    sum_bank_nb_inst = "bank_nb_inst_"+toString(i);
+	  else
+	    sum_bank_nb_inst = "+ bank_nb_inst_"+toString(i) + " " +sum_bank_nb_inst;
+	}
+      
+      _stat->create_expr_average_by_cycle("average_occupation_bank", sum_bank_nb_inst, "", _("Average instruction by cycle (all bank)"));
+      _stat->create_expr_percent         ("percent_occupation_bank" , "average_occupation_bank", toString(_param->_size_queue), _("Percent occupation of reexecute_queue (all bank)"));
+    }
+
+
+    _stat_nb_inst_reexecute = _stat->create_variable("nb_inst_reexecute");
+    _stat_nb_inst_commit    = _stat->create_variable("nb_inst_commit");
+    _stat_nb_spr_access     = _stat->create_variable("nb_spr_access");
+
+    _stat->create_expr_average_by_cycle("average_inst_commit"   , "nb_inst_commit"   , "", _("Average instruction commited by cycle"));
+    _stat->create_expr_average_by_cycle("average_inst_reexecute", "nb_inst_reexecute", "", _("Average instruction reexecuted by cycle"));
+    _stat->create_expr_average_by_cycle("average_spr_access"    , "nb_spr_access"    , "", _("Average spr access by cycle"));
+
+    _stat->create_expr_percent         ("percent_use_interface_commit"    , "average_inst_commit"   , toString(_param->_nb_inst_commit   ), _("Percent usage of commit interface"));
+    _stat->create_expr_percent         ("percent_use_interface_reexecute" , "average_inst_reexecute", toString(_param->_nb_inst_reexecute), _("Percent usage of reexecute interface"));
+    _stat->create_expr_percent         ("percent_use_interface_spr"       , "average_spr_access"    , toString(_param->_nb_inst_reexecute), _("Percent usage of spr interface"));
+    
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,40 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::statistics_deallocation"
+  void Reexecute_unit::statistics_deallocation (void)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    log_printf(INFO,Reexecute_unit,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+    
+    delete _stat;
+    delete [] _stat_bank_nb_inst;
+    
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_transition.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_transition.cpp	(revision 88)
@@ -0,0 +1,151 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::transition"
+  void Reexecute_unit::transition (void)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+	_priority_execute_loop->reset();
+	_priority_queue_in    ->reset();
+
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  _reexecute_queue [i].clear();
+      }
+    else
+      {
+	_priority_execute_loop->transition();
+	_priority_queue_in    ->transition();
+
+	// ===================================================================
+	// =====[ EXECUTE_LOOP / COMMIT ]=====================================
+	// ===================================================================
+	for (uint32_t i=0; i<_param->_nb_bank; ++i)
+	  if (internal_QUEUE_PUSH [i])
+	    {
+	      entry_t * entry = new entry_t;
+	      _reexecute_queue [i].push_back(entry);
+
+	      uint32_t x = internal_QUEUE_NUM_EXECUTE_LOOP [i];
+	      uint32_t y = internal_QUEUE_NUM_INST_EXECUTE [i];
+	      uint32_t z = internal_QUEUE_NUM_INST_COMMIT  [i];
+	      
+	      entry->state        = STATE_SPR_ACCESS;
+	      entry->context_id   = (_param->_have_port_context_id  )?PORT_READ(in_EXECUTE_LOOP_CONTEXT_ID   [x][y]):0;
+	      entry->front_end_id = (_param->_have_port_front_end_id)?PORT_READ(in_EXECUTE_LOOP_FRONT_END_ID [x][y]):0;
+	      entry->packet_id    = (_param->_have_port_rob_ptr     )?PORT_READ(in_EXECUTE_LOOP_PACKET_ID    [x][y]):0;
+	      entry->address      = PORT_READ(in_EXECUTE_LOOP_ADDRESS [x][y]);
+	      entry->data         = PORT_READ(in_EXECUTE_LOOP_DATA    [x][y]);
+	      entry->num_reg_rd   = PORT_READ(in_COMMIT_NUM_REG_RD    [z]);
+	      entry->spr_wen      = internal_QUEUE_INFO [i].spr_wen  ;
+	      entry->reexecute    = internal_QUEUE_INFO [i].reexecute;
+	      entry->type         = internal_QUEUE_INFO [i].type     ;
+	      entry->operation    = internal_QUEUE_INFO [i].operation;
+	      entry->write_rd     = internal_QUEUE_INFO [i].write_rd ;
+	    }
+
+#ifdef STATISTICS
+        if (usage_is_set(_usage,USE_STATISTICS))
+          for (uint32_t i=0; i<_param->_nb_inst_commit; i++)
+            if (internal_COMMIT_VAL [i] and PORT_READ(in_COMMIT_ACK[i]))
+              (*_stat_nb_inst_commit) ++;
+#endif
+
+	// ===================================================================
+	// =====[ SPR ]=======================================================
+	// ===================================================================
+	for (uint32_t i=0; i<_param->_nb_inst_reexecute; i++)
+	  if (internal_SPR_VAL [i] and PORT_READ(in_SPR_ACK [i]))
+	    {
+#ifdef STATISTICS
+              if (usage_is_set(_usage,USE_STATISTICS))
+                (*_stat_nb_spr_access) ++;
+#endif
+	      entry_t * entry = _reexecute_queue [i].front();
+
+	      if (not entry->spr_wen)
+		{
+		  entry->data     =     PORT_READ(in_SPR_RDATA   [i]);
+		  entry->write_rd = not PORT_READ(in_SPR_INVALID [i]);
+		}
+
+	      if (entry->reexecute)
+		entry->state = STATE_REEXECUTE;
+	      else
+		entry->state = STATE_EMPTY;
+	    }
+
+	// ===================================================================
+	// =====[ REEXECUTE ]=================================================
+	// ===================================================================
+	for (uint32_t i=0; i<_param->_nb_inst_reexecute; i++)
+	  if (internal_REEXECUTE_VAL [i] and PORT_READ(in_REEXECUTE_ACK [i]))
+	    // test source
+	    if (not internal_REEXECUTE_ROB_ACK [i])
+	      {
+#ifdef STATISTICS
+                if (usage_is_set(_usage,USE_STATISTICS))
+                  (*_stat_nb_inst_reexecute) ++;
+#endif
+
+		// invalid entry
+		_reexecute_queue [i].front()->state = STATE_EMPTY;		
+	      }
+#ifdef DEBUG_TEST
+	    else
+	      {
+		if (not PORT_READ(in_REEXECUTE_ROB_VAL [i]))
+		  throw ERRORMORPHEO(FUNCTION,toString(_("in_REEXECUTE_ROB_VAL [%d] must be = 1.\n"),i));
+	      }
+#endif
+	
+	// ===================================================================
+	// =====[ End cycle ]=================================================
+	// ===================================================================
+	for (uint32_t i=0; i<_param->_nb_bank; i++)
+	  if (not _reexecute_queue [i].empty() and (_reexecute_queue [i].front()->state == STATE_EMPTY))
+	    {
+	      entry_t * entry = _reexecute_queue [i].front();
+	      _reexecute_queue [i].pop_front();
+	      delete entry;
+
+#ifdef STATISTICS
+              if (usage_is_set(_usage,USE_STATISTICS))
+                (*(_stat_bank_nb_inst [i])) += _reexecute_queue [i].size();
+#endif
+	    }
+      }
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl.cpp	(revision 88)
@@ -0,0 +1,48 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::vhdl"
+  void Reexecute_unit::vhdl (void)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl_body.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl_body.cpp	(revision 88)
@@ -0,0 +1,35 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::vhdl_body"
+  void Reexecute_unit::vhdl_body (Vhdl * & vhdl)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+    vhdl->set_body ("");
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl_declaration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl_declaration.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/src/Reexecute_unit_vhdl_declaration.cpp	(revision 88)
@@ -0,0 +1,34 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Reexecute_unit/include/Reexecute_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace reexecute_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Reexecute_unit::vhdl_declaration"
+  void Reexecute_unit::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_begin(Reexecute_unit,FUNCTION);
+    log_end(Reexecute_unit,FUNCTION);
+  };
+
+}; // end namespace reexecute_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
